
#pragma once


#include "realworld.h"


////////////////////////////////////////////////////////////
// interface functions for engineering design problems.
//


// inputs: 4 variables
// objectives: fabrication cost, deflection
// We handle constraints through penalty perms.
Vector welded_beam_design(Vector const& x);

// inputs: 4 variables
// objectives: mass, braking time
// We handle constraints through penalty perms.
Vector disk_brake_design(Vector const& x);

// inputs: 11 variables
// objectives: different measures of filter quality
Vector optical_filter(Vector const& x);

// inputs: 16 variables; amounts of heat exchanged
// objectives: total cost, energy/fuel cost
Vector heat_exchanger(Vector const& x);

// inputs: 6 variables
// objectives: expected improvement and probability of improvement
Vector hydro_dynamics(Vector const& x);

// inputs: 5 variables
// objectives: fundamental frequency, material cost
Vector vibrating_platform_design(Vector const& x);
