
#include "realworld.h"
#include "ml.h"
#include "design.h"
#include "or.h"

#include <stdexcept>


RealwordFunction getRealworldFunctionByName(std::string const& name)
{
	if (name == "kernel_ridge_regression_parameter_tuning") return kernel_ridge_regression_parameter_tuning;
	else if (name == "neuralnet_double_pole_balancing") return neuralnet_double_pole_balancing;
	else if (name == "auc_maximization") return auc_maximization;
	else if (name == "welded_beam_design") return welded_beam_design;
	else if (name == "disk_brake_design") return disk_brake_design;
	else if (name == "optical_filter") return optical_filter;
	else if (name == "heat_exchanger") return heat_exchanger;
	else if (name == "hydro_dynamics") return hydro_dynamics;
	else if (name == "vibrating_platform_design") return vibrating_platform_design;
	else if (name == "facility_placement") return facility_placement;
	else throw std::runtime_error("[getRealworldFunctionByName] unknown function");
}

RealwordFunction getRealworldFunctionByID(unsigned int id)
{
	if (id == 0) return kernel_ridge_regression_parameter_tuning;
	else if (id == 1) return neuralnet_double_pole_balancing;
	else if (id == 2) return auc_maximization;
	else if (id == 3) return welded_beam_design;
	else if (id == 4) return disk_brake_design;
	else if (id == 5) return optical_filter;
	else if (id == 6) return heat_exchanger;
	else if (id == 7) return hydro_dynamics;
	else if (id == 8) return vibrating_platform_design;
	else if (id == 9) return facility_placement;
	else throw std::runtime_error("[getRealworldFunctionByID] unknown function");
}
